# coding: utf-8

"""
    FINBOURNE Workflow API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 0.1.208
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid_workflow.configuration import Configuration


class LuminesceView(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'view_name': 'str'
    }

    attribute_map = {
        'view_name': 'viewName'
    }

    required_map = {
        'view_name': 'required'
    }

    def __init__(self, view_name=None, local_vars_configuration=None):  # noqa: E501
        """LuminesceView - a model defined in OpenAPI"
        
        :param view_name:  Name of the view in Luminesce (required)
        :type view_name: str

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._view_name = None
        self.discriminator = None

        self.view_name = view_name

    @property
    def view_name(self):
        """Gets the view_name of this LuminesceView.  # noqa: E501

        Name of the view in Luminesce  # noqa: E501

        :return: The view_name of this LuminesceView.  # noqa: E501
        :rtype: str
        """
        return self._view_name

    @view_name.setter
    def view_name(self, view_name):
        """Sets the view_name of this LuminesceView.

        Name of the view in Luminesce  # noqa: E501

        :param view_name: The view_name of this LuminesceView.  # noqa: E501
        :type view_name: str
        """
        if self.local_vars_configuration.client_side_validation and view_name is None:  # noqa: E501
            raise ValueError("Invalid value for `view_name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                view_name is not None and len(view_name) > 512):
            raise ValueError("Invalid value for `view_name`, length must be less than or equal to `512`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                view_name is not None and len(view_name) < 1):
            raise ValueError("Invalid value for `view_name`, length must be greater than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                view_name is not None and not re.search(r'^[\s\S]*$', view_name)):  # noqa: E501
            raise ValueError(r"Invalid value for `view_name`, must be a follow pattern or equal to `/^[\s\S]*$/`")  # noqa: E501

        self._view_name = view_name

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LuminesceView):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LuminesceView):
            return True

        return self.to_dict() != other.to_dict()
